require("external")

function love.load()
	keyboard.setKeyRepeat(true)
	graphics.setDefaultFilter("nearest","nearest",0)
  
	graphics.setLineWidth(1)
	graphics.setBackgroundColor(0,50,100)
  
  screen=display.new(0,0,300,200)
  screen2=display.new(300,200,300,200)
  blocks=texture.new("Blocks.png",8000,"stream")
  
  texture.create(blocks,1,0,0,5,5)
  texture.create(blocks,2,5,0,5,5)
  texture.create(blocks,3,10,0,5,5)
end

x,y,w,h=0,0,40,40
xx,yy,ww,hh=40,40,40,40
xxx,yyy,www,hhh=80,40,40,40
sw,sh=1,1
function love.update()
  texture.clear(blocks)
  
  if keyboard.isDown("up") then y=y-1
  elseif keyboard.isDown("down") then y=y+1 end
  y=math.collisionY(x,y,w,h,xx,yy,ww,hh)
  y=math.collisionY(x,y,w,h,xxx,yyy,www,hhh)
  
  if keyboard.isDown("left") then x=x-1
  elseif keyboard.isDown("right") then x=x+1 end
  x=math.collisionX(x,y,w,h,xx,yy,ww,hh)
  x=math.collisionX(x,y,w,h,xxx,yyy,www,hhh)
  
  if keyboard.isDown("1") then sw=sw-.1; sh=sh-.1
  elseif keyboard.isDown("2") then sw=sw+.1; sh=sh+.1 end
  if keyboard.isDown("escape") then event.quit() end
  
  texture.add({screen,screen2},blocks,1,x,y,0,w,h)
  texture.add({screen,screen2},blocks,3,xx,yy,0,ww,hh)
  texture.add({screen,screen2},blocks,3,xxx,yyy,0,www,hhh)
end

function love.draw()
  graphics.setColor(255,255,255)
  
  local d=screen2
  display.stencil(d)
  display.rectangle(d,"fill",100,100,200)
  display.scale(d,sw,sh)
  display.translate(d,x-((d.w/d.c.w)/2)+(w/2),y-((d.h/d.c.h)/2)+(h/2))
  display.apply(d)
    texture.draw(blocks)
  display.origin()
  display.reset()
  
  local d=screen
  display.stencil(d)
  display.rectangle(d,"fill",200,100,100)
  display.scale(d,sw,sh)
  display.translate(d,x,y)
  display.apply(d)
    texture.draw(blocks)
  display.origin()
  display.reset()
  
  graphics.print("Scale Width: "..sw.."\nScale Height: "..sh.."\nBlock size: 5x5",180)
end
